# -*- coding: utf-8 -*-
"""EXPO_PIPELINE.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1SJtUZgK3oy-nkIvZHzKKj1UKw0dbPFNx

# IMPORTS
"""

!pip install git+https://github.com/tensorflow/docs
# !pip install -q requests

# Commented out IPython magic to ensure Python compatibility.
# %matplotlib inline
import matplotlib as mpl
import matplotlib.pyplot as plt
import numpy as np
import os
import pandas as pd
import sklearn
import sys
import time
import requests
import tensorflow as tf
from tensorflow import keras
import tensorflow_docs as tfdocs
import tensorflow_docs.plots

AUTOTUNE = tf.data.experimental.AUTOTUNE

print("python", sys.version)
for module in mpl, np, pd, sklearn, tf, keras:
    print(module.__name__, module.__version__)

assert sys.version_info >= (3, 5) # Python ≥3.5 required
assert tf.__version__ >= "2.0"    # TensorFlow ≥2.0 required

"""## DOWNLOAD DATA"""

import pathlib
dataset_url = "http://download.tensorflow.org/example_images/flower_photos.tgz"
data_dir = tf.keras.utils.get_file(origin=dataset_url, fname='flower_photos', untar=True)
data_dir = pathlib.Path(data_dir)

# Obtenemos las clases
class_names = list([item.name for item in data_dir.glob('*') if item.name != "LICENSE.txt"])

# Generamos datos (path, classname, label)
data_files = [
    ( str(f), 
      str(f).split('/')[-2], 
      # class_names.index(str(f).split('/')[-2])
    )  for f in list(data_dir.glob('*/*.jpg'))
] 

# Generams dataframe temporal
df_data = pd.DataFrame(data=data_files, columns=["path", "classname"])
df_data.head()

df_data.classname.value_counts()

"""## LOAD DATA WITH TF.DATA"""

def parse_image(filename):
  parts = tf.strings.split(filename, os.sep)
  label = parts[-2]

  image = tf.io.read_file(filename)
  image = tf.image.decode_jpeg(image)
  image = tf.image.convert_image_dtype(image, tf.float32)
  image = tf.image.resize(image, [128, 128])
  return image, label

def show(image, label):
  plt.figure()
  plt.imshow(image)
  plt.title(label.numpy().decode('utf-8'))
  plt.axis('off')

list_ds = tf.data.Dataset.list_files(str(data_dir/'*/*'))

file_path = next(iter(list_ds))
image, label = parse_image(file_path)
show(image, label)

images_ds = list_ds.map(parse_image)
for image, label in images_ds.take(2):
  show(image, label)

"""# GENERATE DATABASE"""

dataset = tf.data.Dataset.list_files(str(data_dir/'*/*'))

TOTAL_EXAMPLES = len(list(dataset))
CLASS_NAMES = np.array([item.name for item in data_dir.glob('*') if item.name != "LICENSE.txt"])
BATCH_SIZE = 32
IMG_HEIGHT = 299
IMG_WIDTH = IMG_HEIGHT

SAMPLES_TRAIN = int(TOTAL_EXAMPLES * 0.8)
SAMPLES_TEST = TOTAL_EXAMPLES - SAMPLES_TRAIN
dataset = dataset.shuffle(TOTAL_EXAMPLES, reshuffle_each_iteration=False)

test_dataset = dataset.take(SAMPLES_TEST)
train_dataset = dataset.skip(SAMPLES_TEST)

"""## ONE HOT LABEL"""

sample = next(iter(train_dataset)).numpy()
parts = tf.strings.split(sample, os.path.sep)
sample, tf.cast(parts[-2] == CLASS_NAMES, dtype=tf.int32)

"""## TRANSFORMATION

### Functions
"""

def flip(x: tf.Tensor) -> tf.Tensor:
    x = tf.image.random_flip_left_right(x)
    return x

def color(x: tf.Tensor) -> tf.Tensor:
    x = tf.image.random_saturation(x, 0.6, 1.6)
    x = tf.image.random_brightness(x, 0.05)
    x = tf.image.random_contrast(x, 0.7, 1.3)
    return x

def rotate(x: tf.Tensor) -> tf.Tensor:
    return tf.image.rot90(x, tf.random.uniform(shape=[], minval=0, maxval=4, dtype=tf.int32))

def zoom(x: tf.Tensor) -> tf.Tensor:
    # Generate 20 crop settings, ranging from a 1% to 20% crop.
    scales = list(np.arange(0.8, 1.0, 0.9))
    boxes = np.zeros((len(scales), 4))
    for i, scale in enumerate(scales):
        x1 = y1 = 0.5 - (0.5 * scale)
        x2 = y2 = 0.5 + (0.5 * scale)
        boxes[i] = [x1, y1, x2, y2]

    def random_crop(img):
        # Create different crops for an image
        crops = tf.image.crop_and_resize([img], boxes=boxes, box_indices=np.zeros(len(scales)), crop_size=(IMG_HEIGHT, IMG_WIDTH))
        # Return a random crop
        return crops[tf.random.uniform(shape=[], minval=0, maxval=len(scales), dtype=tf.int32)]

    choice = tf.random.uniform(shape=[], minval=0., maxval=1., dtype=tf.float32)
    # Only apply cropping 50% of the time
    return tf.cond(choice < 0.5, lambda: x, lambda: random_crop(x))

def augment(img):
    img = flip(img)
    img = color(img)
    img = rotate(img)
    img = zoom(img)
    return img

def get_label(file_path):
    parts = tf.strings.split(file_path, os.path.sep)
    return tf.cast(parts[-2] == CLASS_NAMES, dtype=tf.int32)

def decode_img(file_path):
    img = tf.io.read_file(file_path)
    img = tf.image.decode_jpeg(img, channels=3)
    return tf.image.resize(img, [IMG_WIDTH, IMG_HEIGHT])

def process_path(file_path):
    label = get_label(file_path)
    # load the raw data from the file as a string
    img = decode_img(file_path)
    img = augment(img)
    img = keras.applications.xception.preprocess_input(img)
    return img, label

def process_path_not_augment(file_path):
    label = get_label(file_path)
    # load the raw data from the file as a string
    img = decode_img(file_path)
    img = keras.applications.xception.preprocess_input(img)
    return img, label

def process_path_predict(file_path):
    img = decode_img(file_path)
    img = keras.applications.xception.preprocess_input(img)
    return img, file_path

"""### Train generator with augment"""

augmented_train = (
    train_dataset
    .take(TOTAL_EXAMPLES)
    .cache()
    .shuffle(TOTAL_EXAMPLES//2)
    .map(process_path, num_parallel_calls=AUTOTUNE)
    .batch(BATCH_SIZE)
    .prefetch(AUTOTUNE)
)

"""### Validation Generator"""

validation_batches = (
    test_dataset
    .map(process_path_not_augment, num_parallel_calls=AUTOTUNE)
    .batch(2*BATCH_SIZE)
)

"""### Predict Pre-Process  Generator"""

predict_batches = (
    test_dataset
    .map(process_path_predict, num_parallel_calls=AUTOTUNE)
)

"""## SHOW EXAMPLE"""

plt.figure(figsize=(10, 10))
for images, labels in augmented_train.take(1):
  for i in range(9):
    ax = plt.subplot(3, 3, i + 1)
    plt.imshow(images[i].numpy())
    plt.title(CLASS_NAMES[np.argmax(labels[i])])
    plt.axis("off")

"""# BUILD MODEL

<table>
  <tr>
      <td><img src="https://miro.medium.com/max/1688/1*J8dborzVBRBupJfvR7YhuA.png"/></td>
      <td><img src="https://miro.medium.com/max/945/1*hOcAEj9QzqgBXcwUzmEvSg.png"/></td>
  </tr>
</table>
"""

def make_model():
    n_classes = len(CLASS_NAMES)
    base_model = keras.applications.xception.Xception(include_top=False)
    for layer in base_model.layers:
        layer.trainable = False

    global_pool = keras.layers.GlobalAveragePooling2D()(base_model.output)
    predictions = keras.layers.Dense(n_classes, activation='softmax')(global_pool)

    model = keras.models.Model(base_model.input, predictions)
    model.compile(
        loss="categorical_crossentropy",
        optimizer=keras.optimizers.SGD(lr=1e-3),
        metrics=["accuracy"]
    )
    return model

"""## TensorBoard"""

log_dir = os.path.join(os.getcwd(), 'logs')
tensorboard_callback = tf.keras.callbacks.TensorBoard(log_dir=log_dir, update_freq='batch')

"""## Train no augment"""

model_with_aug = make_model()
aug_history = model_with_aug.fit(
    augmented_train, 
    epochs=20, 
    validation_data=validation_batches,
    callbacks=[tensorboard_callback]
)

# Commented out IPython magic to ensure Python compatibility.
# %load_ext tensorboard
# %tensorboard --logdir {log_dir}

"""# METRICS"""

plt.figure(figsize=(12, 8))
plotter = tensorflow_docs.plots.HistoryPlotter()
# plotter.plot({"Augmented": aug_history, "Non-Augmented": no_aug_history}, metric = "accuracy")
plotter.plot({"Augmented": aug_history}, metric = "accuracy")
plt.title("Accuracy")
plt.ylim([0,1])

plt.figure(figsize=(12, 8))
plotter = tfdocs.plots.HistoryPlotter()
# plotter.plot({"Augmented": aug_history, "Non-Augmented": no_aug_history}, metric = "loss")
plotter.plot({"Augmented": aug_history}, metric = "loss")
plt.title("Loss")
plt.ylim([0,2])

"""# SERVING

## Save Model
Para cargar nuestro modelo entrenado en TensorFlow Serving, primero debemos guardarlo en formato SavedModel. Esto creará un archivo protobuf en una jerarquía de directorios bien definida e incluirá un número de versión. TensorFlow Serving nos permite seleccionar qué versión de un modelo o "servable" queremos usar cuando hacemos solicitudes de inferencia. Cada versión se exportará a un subdirectorio diferente en la ruta dada.
"""

# Fetch the Keras session and save the model
# The signature definition is defined by the input and output tensors,
# and stored with the default serving key
import tempfile
import os

# MODEL_DIR = tempfile.gettempdir()
MODEL_DIR = os.path.join(os.path.abspath(''), 'saved_model')
version = 1
export_path = os.path.join(MODEL_DIR, str(version))
print('export_path = {}\n'.format(export_path))

model = model_with_aug
tf.keras.models.save_model(
    model,
    export_path,
    overwrite=True,
    include_optimizer=True,
    save_format=None,
    signatures=None,
    options=None
)

print('\nSaved model:')
!ls -l {export_path}

!saved_model_cli show --dir {export_path} --tag_set serve

!saved_model_cli show --dir {export_path} --all

"""## Serve your model
Agregue el URI de distribución de TensorFlow Serving como fuente del paquete: Nos estamos preparando para instalar TensorFlow Serving usando Aptitude ya que este Colab se ejecuta en un entorno Debian. Agregaremos el paquete tensorflow-model-server a la lista de paquetes que Aptitude conoce. Tenga en cuenta que estamos corriendo como root.

Nota: Este ejemplo ejecuta TensorFlow Serving de forma nativa, pero también puede ejecutarlo en un contenedor Docker, que es una de las formas más fáciles de comenzar a utilizar TensorFlow Serving.
"""

# This is the same as you would do from your command line, but without the [arch=amd64], and no sudo
# You would instead do:
# echo "deb [arch=amd64] http://storage.googleapis.com/tensorflow-serving-apt stable tensorflow-model-server tensorflow-model-server-universal" | sudo tee /etc/apt/sources.list.d/tensorflow-serving.list && \
# curl https://storage.googleapis.com/tensorflow-serving-apt/tensorflow-serving.release.pub.gpg | sudo apt-key add -

!echo "deb http://storage.googleapis.com/tensorflow-serving-apt stable tensorflow-model-server tensorflow-model-server-universal" | tee /etc/apt/sources.list.d/tensorflow-serving.list && \
curl https://storage.googleapis.com/tensorflow-serving-apt/tensorflow-serving.release.pub.gpg | apt-key add -
!apt update

"""Install tensorflow serving"""

!apt-get install tensorflow-model-server

"""## Start running TensorFlow Serving

Aquí es donde comenzamos a ejecutar TensorFlow Serving y cargamos nuestro modelo. Después de que se carga, podemos comenzar a hacer solicitudes de inferencia usando REST. Hay algunos parámetros importantes:

* ***rest_api_port***: el puerto que usará para las solicitudes REST.
* ***model_name***: lo usará en la URL de las solicitudes REST. Puede ser cualquier cosa.
* **model_base_path**: esta es la ruta al directorio donde guardó su modelo.
"""

os.environ["MODEL_DIR"] = MODEL_DIR

# Commented out IPython magic to ensure Python compatibility.
# %%bash --bg 
# nohup tensorflow_model_server \
#   --rest_api_port=8501 \
#   --model_name=flower_model \
#   --model_base_path="${MODEL_DIR}" >server.log 2>&1

!tail server.log

"""# MAKE A REQUEST
Primero, echemos un vistazo a un ejemplo aleatorio de nuestros datos de prueba.
"""

def show_predict(idx, batch_paths, predictions, class_names):
    class_names = list(class_names)
    # Load Image
    file_path = batch_paths[idx].decode('utf-8')
    img = tf.io.read_file(file_path)
    img = tf.image.decode_jpeg(img, channels=3)

    # Load Title
    pred = predictions[idx]
    # Predictions
    label_classname_pred = class_names[np.argmax(pred)]
    label_index_pred = np.argmax(pred)
    # Real Label
    label_classname = file_path.split(os.path.sep)[-2]
    label_index = class_names.index(label_classname)

    title = 'El modelo detectó que eso era "{}" (class {}), y en realidad era "{}" (class {})'.format(
        label_classname_pred, 
        label_index_pred, 
        label_classname, 
        label_index
    )

    plt.figure()
    plt.imshow(img)
    # plt.imshow(test_images[idx].reshape(IMG_HEIGHT,IMG_WIDTH))
    plt.axis('off')
    plt.title('\n\n{}'.format(title), fontdict={'size': 16})

num_rows = 5
batch_tensor = None
batch_paths  = None
for items in predict_batches.batch(num_rows).take(1):
    batch_tensor = items[0]
    batch_paths = items[1]

batch_paths

batch_paths = batch_paths.numpy()
batch_predict = batch_tensor.numpy() 
batch_predict = batch_predict.tolist()

np.shape(batch_predict)

import json
data = json.dumps({
    "signature_name": "serving_default", 
    "instances": batch_predict
})
print('Data: {} ... {}'.format(data[:50], data[len(data)-52:]))

# import requests
headers = {"content-type": "application/json"}
json_response = requests.post('http://localhost:8501/v1/models/flower_model:predict', data=data, headers=headers)
predictions = json.loads(json_response.text)['predictions']

predictions

for i in range(num_rows):
    show_predict(i, batch_paths, predictions, CLASS_NAMES)

